org.apache.lucene.analysis.id

## Class IndonesianAnalyzer

- java.lang.Object
- - org.apache.lucene.analysis.Analyzer
  - - org.apache.lucene.analysis.util.StopwordAnalyzerBase
    - - org.apache.lucene.analysis.id.IndonesianAnalyzer

All Implemented Interfaces:
  Closeable, AutoCloseable

    public final class IndonesianAnalyzer
    extends StopwordAnalyzerBase

Analyzer for Indonesian (Bahasa)

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer

`Analyzer.GlobalReuseStrategy, Analyzer.PerFieldReuseStrategy, Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

### Field Summary

Fields
`static String` `DEFAULT_STOPWORD_FILE` File containing default Indonesian stopwords.

### Fields inherited from class org.apache.lucene.analysis.util.StopwordAnalyzerBase

`matchVersion, stopwords`

### Constructor Summary

Constructors
Constructor and Description
`IndonesianAnalyzer(Version matchVersion)` Builds an analyzer with the default stop words: `DEFAULT_STOPWORD_FILE`.
`IndonesianAnalyzer(Version matchVersion, CharArraySet stopwords)` Builds an analyzer with the given stop words
`IndonesianAnalyzer(Version matchVersion, CharArraySet stopwords, CharArraySet stemExclusionSet)` Builds an analyzer with the given stop word.

### Method Summary

Methods
`protected Analyzer.TokenStreamComponents` `createComponents(String fieldName, Reader reader)` Creates `Analyzer.TokenStreamComponents` used to tokenize all the text in the provided `Reader`.
`static CharArraySet` `getDefaultStopSet()` Returns an unmodifiable instance of the default stop-words set.

### Methods inherited from class org.apache.lucene.analysis.util.StopwordAnalyzerBase

`getStopwordSet, loadStopwordSet, loadStopwordSet, loadStopwordSet`

### Methods inherited from class org.apache.lucene.analysis.Analyzer

`close, getOffsetGap, getPositionIncrementGap, initReader, tokenStream`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_STOPWORD_FILE

    public static final String DEFAULT_STOPWORD_FILE

File containing default Indonesian stopwords.

See Also:
  Constant Field Values

### Constructor Detail

#### IndonesianAnalyzer

    public IndonesianAnalyzer(Version matchVersion)

Builds an analyzer with the default stop words: `DEFAULT_STOPWORD_FILE`.

#### IndonesianAnalyzer

    public IndonesianAnalyzer(Version matchVersion,
                      CharArraySet stopwords)

Builds an analyzer with the given stop words

Parameters:
  `matchVersion` - lucene compatibility version
  `stopwords` - a stopword set

#### IndonesianAnalyzer

    public IndonesianAnalyzer(Version matchVersion,
                      CharArraySet stopwords,
                      CharArraySet stemExclusionSet)

Builds an analyzer with the given stop word. If a none-empty stem exclusion set is provided this analyzer will add a `KeywordMarkerFilter` before `IndonesianStemFilter`.

Parameters:
  `matchVersion` - lucene compatibility version
  `stopwords` - a stopword set
  `stemExclusionSet` - a set of terms not to be stemmed

### Method Detail

#### getDefaultStopSet

    public static CharArraySet getDefaultStopSet()

Returns an unmodifiable instance of the default stop-words set.

Returns:
  an unmodifiable instance of the default stop-words set.

#### createComponents

    protected Analyzer.TokenStreamComponents createComponents(String fieldName,
                                                  Reader reader)

Creates `Analyzer.TokenStreamComponents` used to tokenize all the text in the provided `Reader`.

Specified by:
  `createComponents` in class `Analyzer`
Returns:
  `Analyzer.TokenStreamComponents` built from an `StandardTokenizer` filtered with `StandardFilter`, `LowerCaseFilter`, `StopFilter`, `KeywordMarkerFilter` if a stem exclusion set is provided and `IndonesianStemFilter`.